//+------------------------------------------------------------------+
//|                                                   BAT ATR v3.mq4 |
//|                                                 Revised by mason |
//+------------------------------------------------------------------+
#property  copyright "Copyright Team Aphid"
#property  link      ""
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 4
#property  indicator_color1  Black
#property  indicator_width1  2
#property  indicator_style1  1
#property  indicator_color2  Red
#property  indicator_width2  2
#property  indicator_style2  1
#property  indicator_color3  Black
#property  indicator_width3  1
#property  indicator_style3  1
#property  indicator_color4  Red
#property  indicator_width4  1
#property  indicator_style4  1

//---- indicator parameters
extern int          FirstDir        = 0;               // 1 = Up,   -1 = Down
extern string       ArrowName       = "PB";
extern int          ATRPeriod       = 2;
extern double       Factor          = 1;
extern bool         MedianPrice     = true;
extern bool         MedianBase      = true;
extern bool         CloseBase       = true;
extern double       Vdistance       = 0;
extern int          Hshift          = 0;
extern double       Vshift          = 0;
extern bool         Continuous      = false;
extern int          BackPeriod      = 0;
extern datetime     PBdatetime      = NULL;

//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];
double     ind_buffer4[];

int limit,pos;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings  
   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexDrawBegin(0,ATRPeriod);
   SetIndexBuffer(0,ind_buffer1);
   SetIndexStyle(1,DRAW_LINE,EMPTY,2);
   SetIndexDrawBegin(1,ATRPeriod);
   SetIndexBuffer(1,ind_buffer2);
   SetIndexStyle(2,DRAW_LINE,EMPTY,2);
   SetIndexDrawBegin(2,ATRPeriod);
   SetIndexBuffer(2,ind_buffer3);
   SetIndexStyle(3,DRAW_LINE,EMPTY,2);
   SetIndexDrawBegin(3,ATRPeriod);
   SetIndexBuffer(3,ind_buffer4);

   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("BAT ATR v4 ("+ATRPeriod+" * "+Factor+")");
   SetIndexLabel(0,"Support");
   SetIndexLabel(1,"Resistance");
   
   if ((ObjectGet(ArrowName,OBJPROP_ARROWCODE)==67)&&(PBdatetime==NULL)) {
       PBdatetime = ObjectGet(ArrowName,OBJPROP_TIME1);
       pos = iBarShift(NULL,0,PBdatetime,true)+Hshift;
    }
    else if (PBdatetime!=NULL) pos=iBarShift(NULL,0,PBdatetime,false)+Hshift;
    else {
        pos=0;
    }
    
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   double PrevUp, PrevDn;
   double CurrUp, CurrDn;
   double PriceCurr, PricePrev;
   double PriceLvl;
   double PriceHLorC;
   double LvlUp = 0;
   double LvlDn = 1000;
   int    Dir = 1;
   int    InitDir,OldDir;
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   if (BackPeriod==0) limit=Bars-counted_bars; else limit=BackPeriod;
   if (pos>0) limit=pos;
//---- fill in buffervalues
   InitDir = 0;
   for(int i=limit; i>=0; i--)
   {
      if (MedianPrice) PriceLvl = (High[i] + Low[i])/2;
      else PriceLvl = Close[i];  
      
      if (MedianBase) {
          PriceCurr = (High[i] + Low[i])/2;
          PricePrev = (High[i-1] + Low[i-1])/2;
          }
      else {
          PriceCurr = Close[i];
          PricePrev = Close[i-1];
         }
      
      if(InitDir == 0) {
         CurrUp=PriceCurr - (iATR(NULL,0,ATRPeriod,i) * Factor);
         PrevUp=PricePrev - (iATR(NULL,0,ATRPeriod,i+1) * Factor);
         CurrDn=PriceCurr + (iATR(NULL,0,ATRPeriod,i) * Factor);
         PrevDn=PricePrev + (iATR(NULL,0,ATRPeriod,i+1) * Factor);
           
         if (CurrUp > PrevUp) Dir = 1;
         LvlUp = CurrUp;
         if (CurrDn < PrevDn) Dir = -1;
         LvlDn = CurrDn;
         InitDir = 1;
         if (FirstDir!=0) Dir=FirstDir;
         OldDir = Dir;
      }
      
      CurrUp=PriceLvl - (iATR(NULL,0,ATRPeriod,i) * Factor);
      CurrDn=PriceLvl + (iATR(NULL,0,ATRPeriod,i) * Factor);

      if (Dir == 1) {  //Support, Uptrend
         if (CurrUp > LvlUp) {
            ind_buffer1[i] = CurrUp-Vdistance;
            ind_buffer3[i] = ind_buffer1[i] - Vshift;
            LvlUp = CurrUp;
         }
         else {
            ind_buffer1[i] = LvlUp-Vdistance;
            ind_buffer3[i] = ind_buffer1[i] - Vshift;
         }
         ind_buffer2[i] = EMPTY_VALUE;
         ind_buffer4[i] = EMPTY_VALUE;
         if (CloseBase) PriceHLorC = Close[i]; else PriceHLorC=Low[i];
         if (PriceHLorC < ind_buffer1[i]) {
            OldDir = Dir;
            Dir = -1;
            LvlDn = 1000;
            continue;
         }
      } //if Dir
      
      if (Dir == -1) {  // Resistance, Downtrend
         if (CurrDn < LvlDn) {
            ind_buffer2[i] = CurrDn+Vdistance;
            ind_buffer4[i] = ind_buffer2[i] + Vshift;
            LvlDn = CurrDn;
         }
         else {
            ind_buffer2[i] = LvlDn+Vdistance;
            ind_buffer4[i] = ind_buffer2[i] + Vshift;
         }
         ind_buffer1[i] = EMPTY_VALUE;
         ind_buffer3[i] = EMPTY_VALUE;
         if (CloseBase) PriceHLorC = Close[i]; else PriceHLorC=High[i];
         if (PriceHLorC > ind_buffer2[i]) {
            OldDir = Dir;
            Dir = 1;
            LvlUp = 0;
         }
      } //if Dir
      if ((!Continuous)&&(OldDir!=Dir)) break;
 
   }  //for 
   

//---- done
   return(0);
  }